// force vc7 to group all shader related stuff into the Shader namespace
#ifdef WIN32
namespace Shader {
#endif

// define inputs from application
struct appin
{
  float4 position   : POSITION;
  float4 texCoords0 : TEXCOORD0;
  float4 texCoords1 : TEXCOORD1;
};

// define outputs from vertex shader
struct vertout
{
  float4 position   : POSITION;
  float4 texCoords0 : TEXCOORD0;
  float4 texCoords1 : TEXCOORD1;
};

vertout main(appin v_in)
{
  vertout v_out;

  // transform vertex position into homogenous clip-space
  v_out.position   = v_in.position;
  v_out.position.w = 1.0;
  v_out.position.z = 0;
  v_out.texCoords0 = v_in.texCoords0;
  v_out.texCoords1 = v_in.texCoords1;

  return v_out;
}

#ifdef WIN32
}
#endif
